const sqlite3 = require('sqlite3').verbose()



const dbRoute = '/root/tea_project/rascunhos.db';


async function writingAromasDb() {
    const aromasProvDb_raw = require('./readingProvAromas');
    const aromasFixDb_raw = require('./readingFixAromas');

    let db = new sqlite3.Database(dbRoute, err =>{
        console.log(err);
    })
    var aromasProvDb = await aromasProvDb_raw.aromasQueryDb().then((te) => {return te})
    var aromasFixDb = await aromasFixDb_raw.aromasQueryFixDb().then((te) =>{return te})
    
    var newProduct = []
    var changes = []
    var prov_dict = {}
    aromasProvDb.forEach((row) =>{
        prov_dict[row.producto] = row.precio
    })
    var fix_dict = {}
        aromasFixDb.forEach((row) =>{
            fix_dict[row.producto] = {'precio_nuevo': row.precio_nuevo, 'precio_viejo': row.precio_viejo, 'variacion': row.variacion, 'date': row.date}
        })
    var d = new Date();
    if (Object.keys(aromasFixDb).length == 0){
        for(const[key, value] of Object.entries(aromasProvDb)){
            db.run("INSERT INTO aromas_fix(producto, precio_viejo, precio_nuevo, variacion, date) VALUES(?,?,?,?,?);", 
                            [value.producto, value.precio, value.precio, 0, `${d.getFullYear()}-${d.getMonth()+1}-${d.getDate()}`], (err) =>{
                                if(err){
                                    console.log(`${value.producto} couldn't be inserted in the db`);
                                    console.log(err)
                                }
                            })
        }
    }else{

        var variacion
        for(const[key, value] of Object.entries(prov_dict))
        
        try{
            if (fix_dict[key].precio_viejo != value){ //aquí se compara los precios recíen crawleados con los ya existentes, value es el reciente
                variacion = (fix_dict[key].precio_viejo/value).toFixed(2);
                changes.push([key, value, variacion]);
                db.run("UPDATE aromas_fix SET precio_viejo = ?, precio_nuevo = ?, variacion = ?, date = ? WHERE producto = ?;", 
                        [fix_dict[key].precio_nuevo, value, variacion, `${d.getFullYear()}-${d.getMonth()+1}-${d.getDate()}`, key],(err) =>{
                    if(err){
                        console.log(`The Database could not be updated with this product ${key}`)
                    }
                    console.log("theorically it was updated")
                })
            }
        }catch(e)
        {
            
            db.run("INSERT INTO aromas_fix(producto, precio_viejo, precio_nuevo, variacion, date) VALUES(?,?,?,?,?);",
                    [key, value, value, 0, `${d.getFullYear()}-${d.getMonth()+1}-${d.getDate()}`])
            newProduct.push([key, value])

            console.log(e)
        }
        
    }
    db.close();
    return[changes, newProduct] //array with the changes in the prices and the new products
};

module.exports.writingAromasDb = writingAromasDb