const sqlite3 = require("sqlite3").verbose()

const dbRoute = '/root/tea_project/rascunhos.db';

async function mistelaneaFixDb(){
    const db = new sqlite3.Database(dbRoute, err =>{
        console.log("Problems opening the database in the readingFixMistelanea");
        console.log("***********************************************************");
        console.log(err);
    })
    return new Promise(resolve =>{
        db.all("SELECT DISTINCT * FROM mistelanea_fix", (err, rows) =>{
            if(err){
                console.log("Problems querying the db from mistelanea_fix")
                console.log("*********************************************")
                console.log("Database will be created")
                db.run('CREATE TABLE IF NOT EXISTS mistelanea_fix (categoria text, producto text, precio_viejo real, precio_nuevo real, variacion real, date text)')
                resolve('empty table')
            }
            db.run("UPDATE mistelanea_fix SET variacion = 0")
            resolve(rows)
        })
    })
    db.close()
}

module.exports.mistelaneaFixDb = mistelaneaFixDb